%%%%%%%%% Globlis felhasznli korltok %%%%%%%

:- use_module(library(clpfd)).
:- multifile clpfd:dispatch_global/4.
:- discontiguous clpfd:dispatch_global/4.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% leq(X,Y):-
% X #=< Y globlis korltknt megvalstva
leq(X,Y):-
	fd_global(leq(X,Y),void,[min(X),max(Y)]).

clpfd:dispatch_global(leq(X,Y),State,State,Actions):-
	dispatch_leq(X,Y,Actions).

dispatch_leq(X,Y,Actions):-
	fd_min(X,MinX), fd_max(X,MaxX),
	fd_min(Y,MinY), fd_max(Y,MaxY),
	( number(MaxX), number(MinY), MaxX =< MinY ->
	    Actions = [exit]
	; Actions = [X in MinX..MaxY, Y in MinX..MaxY]
	).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% sign(X,S):-
% S = sign(X) globlis korltknt megvalstva
sign(X,S):-
	S in -1..1,
	fd_global(sign(X,S),void,[minmax(X),minmax(S)]).

clpfd:dispatch_global(sign(X,S),State,State,Actions):-
	dispatch_sign(X,S,Actions).

dispatch_sign(X,S,Actions):-
	fd_min(X,MinX0), sign_of(MinX0,MinS),
	fd_max(X,MaxX0), sign_of(MaxX0,MaxS),
	fd_min(S,MinS0), sign_min_max(MinS0,MinX,_),
	fd_max(S,MaxS0), sign_min_max(MaxS0,_,MaxX),
	Actions = [X in MinX..MaxX, S in MinS..MaxS|Exit],
	( max(MinS0,MinS) =:= min(MaxS0,MaxS) -> Exit = [exit]
	; Exit = []
	).
		 
% sign_of(X, S): X egsz vagy vgtelen rtk eljele S
sign_of(inf, S) :- !, S = -1.
sign_of(sup, S) :- !, S = 1.
sign_of(X, S) :- S is sign(X).
% sign_min_max(S, Min, Max): sign(x) = S <=> x in Min..Max
sign_min_max(-1, inf, -1).
sign_min_max(0, 0, 0).
sign_min_max(1, 1, sup).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% legf1poz(L):-
% az L listban legfeljebb 1 pozitv egsz szm van, a tbbi mind negatv vagy nulla
	   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% osszege(A,B,C):-
% A+B=C globlis korltknt megvalstva

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%