:- use_module(library(chr)).

% propagci
% konklzi levonsa
:- chr_constraint eso/0, nedves/0, esernyo/0.
eso ==> nedves.
eso ==> esernyo.

% egyszersts
% egyszersts, llapotvltozs, dinamikus viselkeds
:- chr_constraint kelet/0, nyugat/0, eszak/0, del/0.
kelet, nyugat <=> true.
eszak, del <=> true.

% egypagci
% korltok egy rsze nem vltozik
% egy gazdag ember nem hagyja, hogy a bartja szegny maradjon
:- chr_constraint gazdag/1, baratja/2, szegeny/1.
gazdag(X), szegeny(X) <=> fail.
gazdag(X), baratja(X,Y) \ szegeny(Y) <=> gazdag(Y).

:- chr_constraint leq/2.
reflexivity  @ leq(X,X) <=> true.
antisymmetry @ leq(X,Y), leq(Y,X) <=> X = Y.
idempotence  @ leq(X,Y) \ leq(X,Y) <=> true.
transitivity @ leq(X,Y), leq(Y,Z) ==> leq(X,Z).

%Az embereket ember(Nv,Er) korltokkal brzoljuk. Ha van kt
%ugyanolyan ers ember, akkor a nvsorban elbb lev gy sszeveri a
%msikat, hogy annak eggyel cskken az ereje. Akinek elfogy az ereje,
%az meghal. 
:- chr_constraint ember/2.
ember(_,0) <=> true.
ember(N1,E1) \ ember(N2,E2) <=> 
        E1 = E2, N1 @< N2 | 
        E3 is E2-1, write(N1-veri-N2), nl, ember(N2,E3).

:- use_module(library(sets), [intersection/3]).          
:- chr_constraint dom/2.          
dom(_,[]) <=> fail.
dom(X,[Y]) <=> X = Y.
dom(X,L) <=> nonvar(X) | memberchk(X,L).
dom(X,L1), dom(X,L2) <=> intersection(L1,L2,L3), dom(X,L3).

:- chr_constraint primes/1, prime/1.
primes(1) <=> true.
primes(N) <=> ground(N), N>1 | M is N-1, primes(M), prime(N).
prime(X) \ prime(Y) <=> Y mod X =:= 0 | true.

% Rendezs felcserlssel
% Egy szmtmbt brzoljunk a(Index,Ertek) prok alakjban
% brzolunk. rj CHR szablyt, mely megvalstja a tmb rendezst.
:- chr_constraint a/2.
a(I,V), a(J,W) <=> I>J, V<W | a(I,W),a(J,V).

% Az elz pldt hogyan kellene mdostani ahhoz, ha a szmtmbt
% cskken sorrendben szeretnnk rendezni?
:- chr_constraint b/2.
b(I,W), b(J,V) <=> I>J, V<W | b(I,V),b(J,W).

% keresztrejtvny
% Helyezzk el az albbi 6 darab ngy bets szt egy olyan
% keresztrejtvnyben, melynek 4 sora van s a maradk kt sz a
% kzps kt oszlopba kerl.
:- chr_constraint szo/4, megoldas/1.
szo(A1,B1,C1,D1), szo(A2,B2,C2,D2), szo(A3,B3,C3,D3),szo(A4,B4,C4,D4),
szo(B1,B2,B3,B4), szo(C1,C2,C3,C4) <=> megoldas([[A1,B1,C1,D1],
                                                  [A2,B2,C2,D2],
                                                  [A3,B3,C3,D3],
                                                  [A4,B4,C4,D4]]).
teszt_szo:-
        szo(m,a,r,i),
        szo(c,s,a,k),
        szo(s,a,j,t),
        szo(o,t,t,o),
        szo(a,j,a,x),
        szo(a,r,a,t).
